package com.gprinter.zb;

import java.io.IOException;
import java.io.OutputStream;

/* loaded from: com_gprinter_zb.jar:com/gprinter/zb/DitheredImageProvider.class */
public class DitheredImageProvider {
    public static void getDitheredImage(ZebraImageInternal Image, OutputStream var1) throws IOException {
        int w = Image.getWidth();
        int h = Image.getHeight();
        getDitheredImage(w, h, Image, var1);
    }

    protected static void getDitheredImage(int width, int height, ZebraImageInternal var2, OutputStream outputStream) throws IOException {
        int[] w = var2.getRow(0);
        int[] h = var2.getRow(1);
        int ww = (width / 8) + (width % 8 == 0 ? 0 : 1);
        int pix = 8 - (width % 8);
        if (pix == 8) {
            pix = 0;
        }
        byte[] var8 = new byte[ww];
        byte var9 = 0;
        for (int i = 0; i < width; i++) {
            w[i] = convertByteToGrayscale(w[i]);
        }
        for (int i2 = 0; i2 < height; i2++) {
            for (int var11 = 0; var11 < var8.length; var11++) {
                var8[var11] = 0;
            }
            int var112 = 0;
            for (int var12 = 0; var12 < width; var12++) {
                if (var12 % 8 == 0) {
                    var9 = Byte.MIN_VALUE;
                }
                int var13 = w[var12];
                var112 = var12 / 8;
                byte var14 = var13 >= 128 ? (byte) -1 : (byte) 0;
                var8[var112] = (byte) (var8[var112] | (var9 & var14));
                int var15 = var13 - (var14 & 255);
                if (var12 < width - 1) {
                    int[] iArr = w;
                    int i3 = var12 + 1;
                    iArr[i3] = iArr[i3] + ((7 * var15) / 16);
                }
                if (var12 > 0 && i2 < height - 1) {
                    int[] iArr2 = h;
                    int i4 = var12 - 1;
                    iArr2[i4] = iArr2[i4] + ((3 * var15) / 16);
                }
                if (i2 < height - 1) {
                    if (var12 == 0) {
                        h[var12] = convertByteToGrayscale(h[var12]);
                    }
                    int[] iArr3 = h;
                    int i5 = var12;
                    iArr3[i5] = iArr3[i5] + ((5 * var15) / 16);
                }
                if (i2 < height - 1 && var12 < width - 1) {
                    h[var12 + 1] = convertByteToGrayscale(h[var12 + 1]);
                    int[] iArr4 = h;
                    int i6 = var12 + 1;
                    iArr4[i6] = iArr4[i6] + ((1 * var15) / 16);
                }
                var9 = (byte) ((var9 & 255) >>> 1);
            }
            var8[var112] = (byte) (var8[var112] | (255 >>> (8 - pix)));
            outputStream.write(var8);
            w = h;
            h = var2.getRow(i2 + 2);
        }
    }

    private static int convertByteToGrayscale(int var0) {
        int r = (var0 & 16711680) >>> 16;
        int g = (var0 & 65280) >>> 8;
        int b = var0 & 255;
        int gray = (((r * 30) + (g * 59)) + (b * 11)) / 100;
        if (gray > 255) {
            gray = 255;
        } else if (gray < 0) {
            gray = 0;
        }
        return gray;
    }
}
